# RIPN.net domains registration script
# for eggdrop ( 1.6.15 ) http://www.eggheads.org
# version: 1.0b by 
# CoolCold <coolcold at coolcold.org>
# #rea@irc.coolcold.org:6667
#
#  __    __  __    _           _    
# \  \  /  /|  \  | |         | |   
#  \  \/  / |   \ | |  ____  _| |_  
#   \    /  | |\ \| | /  _ \|_   _| 
#   /    \  | | \   | | /_\/  | |   
#  /  /\  \ | |  \  | | \__   | |__ 
# /__/  \__\|_|   \_| \____/  \___/ 
#
# http://xnet.net.ru irc://xnet.net.ru
#
# Created with FAR ( http://www.farmanager.com )
# and colorer ( http://colorer.sf.net )
#
# $Id:	ripn.tcl v 1.0 29.05.2004 06:44 CoolCold Exp $
#
# Requirements:
# eggdrop (windrop?) 1.6.15,tcl 8.4.5(8.3.* should be ok),mutt or 
# other email client which accepts email data from stdout and can be
# said to use custom "From:" field.For mutt it can be done with
# setting environment variable value "EMAIL"

# Tested on eggdrop 1.6.15,tcl 8.3.4,8.4.6

# TODO
# simple auto zone creation for ISC BIND http://www.isc.org/index.pl?/sw/bind/

# Status:DONE
#
# TODO
# General settings such as debugmode,debugmode email address and access flags
# to be configurable through partyline,not editing script file.
# Looks like it's more secure to leave other settings to be accessible
# only by editing script file.

# Status:in progress

# TODO
# Russian language help messages pack

# Status:just idea...will cause all script structure to be rewritten

# TODO
# Ini file reader/writer like MS Windows API GetPrivateProfileString
# and WritePrivateProfileString,cuz it rocks!

# comment for russian users:
# zaebalo menya kazhdiy raz pisat' otdel'niy parser/reader/writer,
# nada 4to nit' universal'noe uzhe,len' dvigatel' progressa for sure :)

# Status:in da head

###########################################################################
# Using - change debugmode to 0 to enable request sending to RIPN         #
# bla bla...                                                              #
#                                                                         #
###########################################################################
namespace eval ripn {
	
	#default settings - You may change them if u wanna
	set settings_file "ripn.settings.ini"

	#debug mode - sends mail to ur mail not to RIPN and hides passwords
	set debugmode "1"

	#debugmode mail address
	set d_mail "coolcold@coolcold.org"

	#access flags - user must has this flag to be allowed to use RIPN commands
	set accflags "R|-"
	
	#settings array,overriden by config file settings
	array set settings {
		debugmode "1"
		d_mail "coolcold@coolcold.org"
		accflags "R|-"
	}

	#comment next line to disable die command (just to make sure you've got
	#a look on settings)

	#die "I didn't look through ripn.tcl settings!"

	#other settings shouldn't be configured in runtime,imho
	#trigger...really...nothing more
	set trig "!ripn"
	#result file with reg request
	set fname "ripn.reg.form.txt"
	#just log file :)
	set cmdlog "ripn.cmd.log.txt"
	#RIPN mail processor's address
	set ripnmail "ru-dns@ripn.net"

	#command to execute to send mail
	set cmd "cat $fname | mutt $ripnmail"
	if {$settings(debugmode)=="1"} {set cmd "cat $fname | mutt $settings(d_mail)"}

	#template fields

	#let's empty tfields list on startup or on rehash it'll be appended and appened ;)
	set tfields ""
	lappend tfields "passwd" "mnt-by" "admin-o" "e-mail"

	foreach b [array names tfields_help *] {
    	catch {unset tfields_help($b)}
 	}

	array set tfields_help {
		passwd "Your RIPN password, confirmates Your authority to RIPN"
		mnt-by "Maintainer handle, sets person who owns domain"
		admin-o "Administrator of Your RIPN records"
		e-mail "Set email address which should be used as \"From:\" header while emailing to RIPN automata"
	}
	
	#unsetting array - thanks to Shrike < shrike at eggdrop.org.ru > for this code
	foreach b [array names dnsfields *] {
    	catch {unset dnsfields($b)}
 	}
	
	array set dnsfields {mx MX hostmaster HOSTMASTER www WWW}

	foreach b [array names dnsfields_help *] {
    	catch {unset dnsfields_help($b)}
 	}

	array set dnsfields_help {
		mx "MX field is responsible for Mail eXchange,in other words it sets email server's ip address"
		hostmaster "email address of person who is responcible for this domain/zone"
		www "ip address of www.domain.com"
	}

	set options ""
	lappend options "createzone"
	foreach b [array names options_help *] {
    	catch {unset options_help($b)}
 	}
	
	array set options_help {
		createzone "Responcible if to create zone file for ISC BIND after registration request or not,set to 1 to enable"
	}

	#different triggers
	set cmd_ident "ident"
	set cmd_set "set"
	set cmd_reg "register"
	set cmd_view "view"
	set cmd_help "help"


	#################################################
	#                                               #
	# it's not recommended to change anything below #
	# until u realize what the fuck are you doing ! #
	#                                               #
	#################################################
	#templates
	set template_head "lang: RU\naction: NEW\n"
	set template_end "source: RIPN"

	
	#whois request shell's cmd
	set cmd_whois "whois"


	#script info
	set author "CoolCold <menya at vse.zae.blo.org.ru>"
	set ver "1.0b"
	set info "RIPN.net domain registration script by $author"
	set infoline "$info version $ver"
}

proc ::ripn::trigger { nick uhost hand rest } {
variable fname;variable template_head;variable template_end
variable cmd;variable cmd_whois;variable cmd_ident;variable cmd_set
variable cmd_reg;variable cmd_view;variable cmd_help;variable tfields
variable dnsfields
variable dnsfields_help;variable tfields_help;variable options;variable options_help
variable settings
global env botnick lastbind

	#first of all,let check user's flags & identification
	if {![matchattr $hand $settings(accflags)]} {return 0} 

	#flags are ok
	set cmd1 "";set cmd1 [lindex [split $rest ] 0]
	
	#begin of switch
	switch -exact -- [string tolower $cmd1]\
		"$cmd_ident" {
		set pass "";set pass [lindex [split $rest ] 1]
		if {[passwdok $hand $pass]} {
			putserv "NOTICE $nick :RIPN:You have been identified,auto unident within 5 minutes"
			setuser $hand XTRA IDENTIFY "1"
			add2log "RIPN:$hand ($nick) has been successfully identified"
		} else {
			add2log "RIPN:identification for $hand ( $nick ) failed";return 0
		}
	}\
		"$cmd_set" {
			if {![getuser $hand XTRA IDENTIFY]} {
				putserv "NOTICE $nick :RIPN Help:You are not identifyed,use \"/msg $botnick $lastbind $cmd_ident <password>\" to identify Yourself,where <password> is Your bot password"
				add2log "RIPN:$cmd_set from $hand ( $nick ) failed - not identifyed";return 0
			}
			set field "";set field [lindex [split $rest] 1]
			set value "";set value [lindex [split $rest] 2]
			if {$field==""} { ::ripn::trigger $nick $uhost $hand "help set";return 0}
			if {[lsearch -exact $tfields [string tolower $field]]!="-1"} {
				#setting values
				setuser $hand XTRA [string tolower $field] "$value"
				if {$value==""} {putserv "NOTICE $nick :RIPN:***Please note,You've submitted empty value for $field"}
				add2log "RIPN:$hand ( $nick ) changed value of $field to \"$value\" (RIPN Related)"
				putserv "NOTICE $nick :RIPN:New value \"$value\" set for $field"
				if {$field=="admin-o" && $value!=""} {
					#let's try to autodetect values and show hint
					#checking for symbols to prevent shell commands/scripts execution
    					set mask {^[A-Za-z0-9\-]+$}
    					set isbad [regexp $mask $value]
    					if {$isbad=="1"} {
    						#let's get whois data
						if {![catch {set result [eval [concat exec -- $cmd_whois $value]]}]} {
							set whoisdata [split $result \r\n]
							if {[llength $whoisdata]>0} {
							    foreach {j} $tfields {
									set c "-1";set piu ""
									foreach {i} $whoisdata {
								    	incr c
								    	if {[string match "$j:*" $i]} {
											lappend piu "$c"
								    	}
									}
    								if {$piu!=""} {
    									foreach {k} $piu {
    									    putserv "NOTICE $nick :RIPN: Hint: [lindex $whoisdata $k]"
										}
    								}
    							}
							}
						} else { putserv "NOTICE $nick :RIPN:Error message - unable to use $cmd_whois $value"}
    					}

				}
			} elseif {[array names dnsfields [string tolower $field]]!=""} {
				#DNS related fields
				setuser $hand XTRA [string tolower $field] "$value"
				if {$value==""} {putserv "NOTICE $nick :RIPN:***Please note,You've submitted empty value for $field"}
				add2log "RIPN:$hand ( $nick ) changed value of $field to \"$value\" (DNS Related)"
				putserv "NOTICE $nick :RIPN:New value \"$value\" set for $field"
			} elseif {[lsearch -exact $options [string tolower $field]]!="-1"} {
				if {$value==""} {putserv "NOTICE $nick :RIPN:***Please note,You've submitted empty value for $field"}
				setuser $hand XTRA [string tolower $field] "$value"
				add2log "RIPN:$hand ( $nick ) changed value of $field to \"$value\" (General settings related)"
				putserv "NOTICE $nick :RIPN:New value \"$value\" set for $field"
			} else {
				putserv "NOTICE $nick :There is no such field \"$field\",use \"/msg $botnick $lastbind $cmd_help $cmd_set\" to read more"
			}
		} \
		"$cmd_view" {
			if {![getuser $hand XTRA IDENTIFY]} {
				putserv "NOTICE $nick :RIPN Help:You are not identifyed,use \"/msg $botnick $lastbind $cmd_ident <password>\" to identify Yourself,where <password> is Your bot password"
				add2log "RIPN:$cmd_view from $hand ( $nick ) failed - not identifyed";return 0
			}
			putserv "NOTICE $nick :RIPN - Your Current Info configuration"
			putserv "NOTICE $nick :RIPN:   field     value"
			foreach {i} $tfields {
				set bla [getuser $hand XTRA $i]
				if {$i=="passwd"} {set bla "*******"}

				putserv "NOTICE $nick :RIPN:  $i $bla"
			}
			foreach {i} [array names dnsfields] {
				set bla [getuser $hand XTRA [lindex [array get dnsfields $i] 1]]
				putserv "NOTICE $nick :RIPN:  $i $bla"
			}
			foreach {i} $options {
				set bla [getuser $hand XTRA $i]
				putserv "NOTICE $nick :RIPN:  $i $bla"
			}
		} \
		"$cmd_help" {
			if {![getuser $hand XTRA IDENTIFY]} {
				putserv "NOTICE $nick :RIPN Help:You are not identifyed,use \"/msg $botnick $lastbind $cmd_ident <password>\" to identify Yourself,where <password> is Your bot password"
				add2log "RIPN:$cmd_help from $hand ( $nick ) failed - not identifyed";return 0
			}
			set cmd1 "";set cmd1 [lindex [split $rest ] 1]
			switch -exact [string tolower $cmd1] \
				"$cmd_ident" {
					putserv "NOTICE $nick :RIPN Help: format is:\"/msg $botnick $lastbind $cmd_ident <password>\""
					putserv "NOTICE $nick :RIPN Help: identifyes u to script,use ur bot password to identify"
				} \
				"$cmd_set" {
					set cmd2 "";set cmd2 [lindex [split $rest ] 2]
					if {$cmd2==""} {
    					putserv "NOTICE $nick :RIPN Help: format is:\"/msg $botnick $lastbind $cmd_set <option> <value>\""
    					putserv "NOTICE $nick :RIPN Help: sets ur RIPN details,such as maintainer etc and DNS related details such as MX etc"
    					foreach {i} $tfields {
    						append bla "\"$i\" "
    					}
    					putserv "NOTICE $nick :RIPN Help:RIPN related fields are:$bla"
    					set i "";set bla ""
    					foreach i [array names dnsfields] {
    						append bla "\"$dnsfields($i)\" "
    					}
    					putserv "NOTICE $nick :RIPN Help:DNS related fields are:$bla"
    					set i "";set bla ""
    					foreach i  $options {
    						append bla "\"$i\" "
    					}
    					putserv "NOTICE $nick :RIPN Help:General settings:$bla"

					} else {
						if {[array names dnsfields_help [string tolower $cmd2]]!=""} {
							putserv "NOTICE $nick :RIPN Help:[lindex [array get dnsfields_help [string tolower $cmd2]] 1]"
						} elseif {[array names tfields_help [string tolower $cmd2]]!=""} {
							putserv "NOTICE $nick :RIPN Help:[lindex [array get tfields_help [string tolower $cmd2]] 1]"
						} elseif {[lsearch -exact $options [string tolower $cmd2]]!="-1"} {
							putserv "NOTICE $nick :RIPN Help:[lindex [array get options_help [string tolower $cmd2]] 1]"
						} else {
							putserv "NOTICE $nick :RIPN Help: There is no such parameter \"$cmd2\",use \"/msg $botnick $lastbind $cmd_help $cmd_set\" to read more"
						}
					}
				} \
				"$cmd_view" {
					putserv "NOTICE $nick :RIPN Help: format is:\"/msg $botnick $lastbind $cmd_view\""
					putserv "NOTICE $nick :RIPN Help: let u see u current settings"
				} \
				"$cmd_reg" {
					putserv "NOTICE $nick :RIPN Help: format is:\"/msg $botnick $lastbind $cmd_reg <domain name> <nameserver1> <nameserver2> <description (english)>\""
					putserv "NOTICE $nick :RIPN Help: let u send register request to RIPN with data u provided and template fields u've set with \"/msg $botnick $lastbind $cmd_set\""
				} \
				default {
					putserv "NOTICE $nick :RIPN Help: format is:\"/msg $botnick $lastbind $cmd_help <command>\""
					putserv "NOTICE $nick :RIPN Help: shows u brief help for <command>"
					putserv "NOTICE $nick :RIPN Help: available commands are: \"$cmd_ident\" \"$cmd_set\" \"$cmd_view\" \"$cmd_reg\""
				}
		} \
		"$cmd_reg" {
			#oh fuck,file creating func here
			if {![getuser $hand XTRA IDENTIFY]} {
				putserv "NOTICE $nick :RIPN Help:You are not identifyed,use \"/msg $botnick $lastbind $cmd_ident <password>\" to identify Yourself,where <password> is Your bot password"
				add2log "RIPN:$cmd_reg from $hand ( $nick ) failed - not identifyed";return 0
			}

				set bla [split $rest ]
            	set dmn [lindex $bla 1];set ns1 [lindex $bla 2];set ns2 [lindex $bla 3]
            	set descr [concat [lrange $bla 4 end]]
            	if {$dmn==""} {putserv "NOTICE $nick :RIPN: Error message - missed parameter \"<domain name>\"";return 0}
            	if {$ns1=="" || $ns2==""} {putserv "NOTICE $nick :RIPN: Error message - missed parameter \"<nameserver1> or <nameserver2>\"";return 0}
            	if {$descr==""} {putserv "NOTICE $nick :RIPN: Error message - missed parameter \"<description>\"";return 0}
            	#let's check for preconfigured params
            	set c "0"
            	foreach {i} $tfields {
            		set value [getuser $hand XTRA $i]
            		if {$value==""} {set c "1";putserv "NOTICE $nick :RIPN: Error message - missed RIPN related field \"$i\""}
            	}
            	if {$c=="1"} {putserv "NOTICE $nick :RIPN: Error message - some RIPN related params are missed,please refine. Use \"/msg $botnick $lastbind $cmd_help $cmd_set\"";return 0}
            	#all params are ok
            	#please note,param data not checked!
            	#let's write to log
            	add2log "RIPN:$hand ( $nick,[getuser $hand XTRA "admin-o"] ) requested rigistration for $dmn"
            	#let's create file if it doesn't exists
            	if {![file exists $fname]} {set fid [open $fname w];puts $fid "";close $fid}
            	#let's open file for writing...
            	set fid [open $fname "TRUNC RDWR"]
            	puts $fid $template_head
            	if {$settings(debugmode)!="1"} {
            		puts $fid "passwd: [getuser $hand XTRA "passwd"]"
            	} else { puts $fid "passwd: debug_mode_restrictions_in_apply"
            	}
            	puts $fid "\n\#\[DOMAIN TEMPLATE\]\#\n"
            	puts $fid "domain: $dmn"
            	puts $fid "descr: $descr"
            	puts $fid "comp-d: $descr"
            	puts $fid "admin-o: [getuser $hand XTRA "admin-o"]"
            	puts $fid "nserver: $ns1"
            	puts $fid "nserver: $ns2"
            	puts $fid "mnt-by: [getuser $hand XTRA "mnt-by"]"
            	puts $fid $template_end
            	close $fid
            	#now it should be emailing command ;)
            	#setting "From" field to our admin address ( mutt's feature )
            	set env(EMAIL) [getuser $hand XTRA "e-mail"]
				set err "";catch {set result [eval [concat exec -- $cmd]]} err
				if {$err!=""} { 
					putserv "NOTICE $nick :RIPN:Error while sending mail"
					putserv "NOTICE $nick :RIPN:Error info:$err"
				} else {
					if {$settings(debugmode)!="1"} {
						putserv "NOTICE $nick :RIPN:Mail to RIPN.NET mail processor has been sent"
					} else {
						putserv "NOTICE $nick :RIPN:Debug mode restrictions in apply,password hidden,mail sent to $settings(d_mail)"
					}
				}
				set zonetmp [createzone $hand $ns1 $ns2]
				if {$zonetmp!="-1"} {
					set zonetmp [split "$zonetmp" \r\n]
					foreach {i} $zonetmp {
						putserv "NOTICE $nick :$i"
					}
				} else {putlog "create zone failed"}

		} \
		default {
			::ripn::trigger $nick $uhost $hand "$cmd_help"
		}
	
#end if switch	
	
return 0	
}

proc ::ripn::createzone {hand ns1 ns2 } {
variable dnsfields;variable options
	if {[getuser $hand XTRA [lindex $options 0]]!="1"} {return "-1"}
	set mx [getuser $hand XTRA [lindex [array get dnsfields "mx"] 1]]
	set www [getuser $hand XTRA [lindex [array get dnsfields "www"] 1]]
	set hostmaster [getuser $hand XTRA [lindex [array get dnsfields "hostmaster"] 1]]
	if {$mx=="" || $www=="" || $hostmaster==""} { return "-1"}
	set serial [strftime "%Y%m%d01"]
	regsub -all -- "@" $hostmaster "\." hostmaster
	append zone "@\011\011IN\011\011SOA\011$ns1.\011$hostmaster.\011 (\n"
	append zone "\t\t\t$serial\t;serial number\n"
	append zone "\t\t\t6H\t; refresh within a 6 hours\n"
	append zone "\t\t\t1H\t; retry every hour\n"
	append zone "\t\t\t2W\t; expire after 14 days\n"
	append zone "\t\t\t3H\t; default ttl is set to maximum value\n"
	append zone "\t\t\t)\n"
	append zone "\t\t\tNS\t$ns1\t;primary nameserver\n"
	append zone "\t\t\tNS\t$ns2\t;secondary nameserver\n"
	append zone "\t\t\tMX\t10\t$mx\n"
	append zone "www\t\t\tA\t$www\n"
	append zone "@\t\t\tA\t$www\n"
	return $zone
	
}


### Adds <text> to commands log file with timestamp
proc ::ripn::add2log { text } {
variable cmdlog
    if {![file exists $cmdlog]} {set fs [open $cmdlog w];puts $fs "";close $fs;}
	set fs [open $cmdlog "APPEND RDWR"]
	puts $fs "[strftime "%a %d %b %Y %H:%M:%S %z"]: $text"
	close $fs
return 1
}

### writes "not idented" flag into user's data
proc ::ripn::unidentify_all {min hour day month year} {
variable settings
	foreach user_list [userlist $settings(accflags)] {
		setuser $user_list XTRA IDENTIFY "0"
	}
}

proc ::ripn::loadsettings { } {
variable settings_file;variable settings
#creating file if it doesn't exists
if {![file exists $settings_file]} {set fs [open $settings_file w];puts $fs "";close $fs;}

}

bind msg -|- "$::ripn::trig" ::ripn::trigger

### Clearing Id flag every five minutes 
bind time - "?5 * * * *" ::ripn::unidentify_all
bind time - "?0 * * * *" ::ripn::unidentify_all

putlog "$::ripn::infoline loaded"